<template>
    <div class="text-center">
        <v-dialog v-model="dialog" width="650" v-if="isCurrentUserAllowed" ref="dialog">
            <template v-slot:activator="{ on, attrs }">
                <v-btn v-if="isAdd" outlined color="green" elevation="5"
                       class="white--text"
                       v-bind="attrs" v-on="on"
                       @click="setField"
                >
                    {{ $t("LNG_FIELDS_BTNADD") }}
                </v-btn>
                <v-btn v-else
                       v-bind="attrs" v-on="on"
                       x-small
                       fab
                       style="background-color: transparent; box-shadow: none"
                       @click="setField"
                >
                    <v-icon color="primary">mdi-pencil</v-icon>
                </v-btn>
            </template>
            <v-card>
                <v-card-title class="headline blue lighten-2 white--text" color="#0BBBEF">
                    {{ (isAdd) ? $t('LNG_FIELD_ADD') : $t('LNG_FIELD_EDIT') }}
                    <v-spacer></v-spacer>
                    <v-btn color="error" fab small @click="cancel">
                        <v-icon color="white">mdi-close</v-icon>
                    </v-btn>
                </v-card-title>
                <v-card-text style="padding: 24px">
                    <v-form ref="form" class="px-3">
                        <v-row>
                            <v-col cols="10">
                                <v-text-field
                                    v-model="fieldName"
                                    :label="$t('LNG_FIELD_NAME')"
                                    :rules="[v => !!v || $t('LNG_LESSON_REQUIRED')]"
                                    required
                                    color="#0BBBEF"
                                    clearable
                                />
                            </v-col>
                            <v-col cols="2">
                                <v-tooltip bottom>
                                    <template v-slot:activator="{ on, attrs }">
                                        <span v-bind="attrs" v-on="on">
                                            <icon-picker v-model="icon"/>
                                        </span>
                                    </template>
                                    <span>{{ $t("LNG_FIELD_ICON_TOOLTIP") }}</span>
                                </v-tooltip>
                            </v-col>
                        </v-row>
                        <v-row>
                            <v-col cols="12">
                                <v-textarea
                                    v-model="description"
                                    :label="$t('LNG_FIELD_DESCRIPTION')"
                                    clearable
                                    auto-grow
                                    filled
                                    color="#0BBBEF"
                                />
                            </v-col>
                        </v-row>
                        <v-row>
                            <v-col cols="12">
                                <v-autocomplete
                                    v-model="teachers"
                                    :items="getTeacherEmailArray()"
                                    :label="$t('LNG_FIELD_TEACHERS')"
                                    :rules="[teachers.length>0 || $t('LNG_LESSON_ATLEASTONETEACHER')]"
                                    required
                                    chips
                                    multiple
                                    clearable
                                    color="#0BBBEF"
                                />
                            </v-col>
                        </v-row>
                        <v-row>
                            <v-col cols="12">
                                <v-autocomplete
                                    v-model="students"
                                    :items="studentGroup"
                                    :label="$t('LNG_FIELD_STUDENTS')"
                                    chips
                                    multiple
                                    clearable
                                    color="#0BBBEF"
                                />
                            </v-col>
                        </v-row>
                        <v-row>
                            <v-col cols="12" class="text-center">
                                <v-btn
                                    color="error"
                                    class="mr-4"
                                    @click="cancel"
                                >
                                    {{ $t("LNG_FIELD_CANCEL") }}
                                </v-btn>
                                <v-btn
                                    :disabled="!valid"
                                    color="success"
                                    class="mr-4"
                                    @click="submit"
                                >
                                    {{ $t("LNG_FIELD_SUBMIT") }}
                                </v-btn>
                            </v-col>
                        </v-row>
                        <v-row>
                            <v-col cols="12" class="text-center mt-2"
                                   v-if="requestOK || requestFail">
                                <p :style="{ color: (requestOK) ? '#0ABBEF' : '#ff0000'}"
                                   class="mb-n2">
                                    {{ message }}
                                </p>
                            </v-col>
                        </v-row>
                    </v-form>
                </v-card-text>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
import FieldService from "@/services/api/fields"
import { mapGetters } from "vuex";
import IconPicker from "@/components/IconPicker.component";

export default {
    name: 'FieldEdit',
    components: { IconPicker },
    props: {
        isAdd: Boolean,
        currentFieldId: Number,
    },
    data: () => ({
        dialog: false,
        valid: true,
        currentTeacher: "",
        fieldName: "",
        icon: "",
        description: "",
        teachers: [],
        students: [],
        requestOK: false,
        requestFail: false,
        message: ""
    }),
    computed: {
        ...mapGetters([
            'user',
            'teachersInfos',
            'studentGroup',
        ]),
        isCurrentUserAllowed() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN');
        }
    },
    watch: {
        dialog: function (dialog) {
            if (!dialog) {
                this.cancel();
            }
        }
    },
    methods: {
        // Fill in the form's fields according to the button type (add or modify)
        async setField() {
            if (this.isAdd) {
                if (this.user.type === "TEACHER") {
                    this.teachers.push(this.user.email);
                }
            } else {
                const field = await FieldService.getField(this.currentFieldId);

                this.fieldName = field.field_name;
                this.description = field.description;
                this.icon = field.icon;
                this.students = field.groups;
                field.teachers.forEach((el) => {
                    this.teachers.push(el.email);
                })
            }
        },
        // Get the array of all teachers' emails
        getTeacherEmailArray() {
            let emails = [];
            this.teachersInfos.forEach(el => {
                emails.push(el.email);
            })
            return emails;
        },
        // Submit method
        async submit() {
            if (this.$refs.form.validate()) {

                // Get teachers infos from chosen teachers emails
                let chosenTeachersInfos = [];
                this.teachers.forEach(email => {
                    this.teachersInfos.forEach(info => {
                        if (email === info.email) {
                            const teacherInfo = {
                                email: info.email,
                                first_name: info.first_name,
                                group: info.group,
                                login: info.login,
                                name: info.name,
                                type: info.type
                            }
                            chosenTeachersInfos.push(teacherInfo);
                        }
                    })
                })

                // Create the data which will be send
                let data = {
                    description: this.description,
                    field_name: this.fieldName,
                    icon: this.icon,
                    groups: this.students,
                    teachers: chosenTeachersInfos
                }

                // Manage the HTTP request according to the chosen form
                if (this.isAdd) {
                    FieldService.fieldPOST(data)
                        .then((res) => {
                            this.manageHTTPCodeReturned(res.status);
                        })
                } else {
                    setTimeout(() => {
                        this.cancel();
                    }, 1000);
                    data.id = this.currentFieldId;
                    FieldService.fieldPATCH(data)
                        .then((res) => {
                            this.manageHTTPCodeReturned(res.status);
                        });
                }

                // Update the field list
                await new Promise(r => setTimeout(r, 1000));
                this.$emit('clicked'); // Emit a 'clicked' event to the parent component which will use a method to update this component
            }
        },
        // Display a message for the user with the HTTP request and the returned code
        manageHTTPCodeReturned(code) {
            this.requestOK = false;
            this.requestFail = false;
            switch (code) {
                case 200:
                    this.requestOK = true;
                    this.message = this.$t("LNG_FIELD_UPDATED");
                    setTimeout(() => {
                        this.$emit("updated");
                        this.cancel();
                    }, 1000);
                    break;
                case 201:
                    this.requestOK = true;
                    this.message = this.$t("LNG_FIELD_ADDED");
                    setTimeout(() => {
                        this.$emit("updated");
                        this.cancel();
                    }, 1000);
                    break;
                case 400:
                    this.requestFail = true;
                    this.message = this.$t("LNG_FIELD_ERROR400") + " Code : " + code;
                    break;
                case 404:
                    this.$router.push({ name: '404 Not found' });
                    break;
                default:
                    if (code >= 400 && code < 500) {
                        this.requestFail = true;
                        this.message = this.$t("LNG_FIELD_CLIENTERROR") + " Code : " + code;
                    } else if (code >= 500 && code < 600) {
                        this.requestFail = true;
                        this.message = this.$t("LNG_FIELD_SERVERERROR") + " Code : " + code;
                    } else {
                        this.requestFail = true;
                        this.message = this.$t("LNG_FIELD_FAILED") + " Code : " + code;
                    }
            }
        },
        cancel() {
            this.$refs.form.reset();
            this.requestOK = false;
            this.requestFail = false;
            this.dialog = false;
        }
    }
}
</script>